PD HELP FILE FOR CBREEZE                         DLIBS PROCESS FUNCTIONS
based on dlibs v1.2 manual

Intended for use with the mouse     ALT & CLICK        Function search
orientated search commands shown    CONTROL & CLICK    Word search
to the right.                       ALT & >            Go to next occurance
                                    CNT & SHFT & CLK   Find previous

Suggest return to menu by macro  - (,),/ - of  CNTRL ALT UP, SHIFT DOWNS
Items in /* comment marks */ available by word search only

/*  PROCESS CONTROL: */

/*   variables:  _STKSIZ  *etext  *edata  *end */
_initargs,  main,     _main,    exit,   _exit,   abort,   getpid,  getenv,
putenv,     shell,    system,   forkl,  forklp,  forkle,  forklpe, forkv,
forkvp,     forkve,   forkvpe,  wait,   gemdos,  bios,    xbios,   bdos,
setjmp,     longjmp,  catch,    throw,




PROCESS CONTROL:

long _STKSIZ = 4096L;
/*  This variable defines the amount of run-time stack space to be */
/*  reserved.  The default value is 4K, which is more than enough */
/*  for most applications.  Since dynamic memory is NOT allocated */
/*  from the stack, this value need only be large enough to handle */
/*  local variables and deep recursion. */

char *etext;
char *edata;
char *end;
/*  These variables point to the first byte beyond the end of the */
/*  text, data and BSS segments respectively.  They are provided */
/*  for compatibility. */

void _initargs(char *cmdline, int cmdlen)
{
/*  Process the command arguments, either parsing the command line
	or copying XARG arguments, and retrieve the environment string.
	This function is called from the startup module very early on.
	Values to be passed to the user's main() function are stored in
	the global variables "_argc" and "_argv".  The startup module
	initiallizes these variables to indicate that no arguments are
	available, and sets "_envp" from the value in the basepage.  If
	a program doesn't use arguments, this function can be replaced
	by one like the one in <sys\minimum.h> to make the program smaller.
 */
}
int main(int argc, char *argv[], char *envp)
{
/*  This function is not actually in the standard libraries, but
	must be present somewhere in the user's code.  The parameters
	passed to it by _main() are the number of arguments in the
	command line, a pointer to a list of pointers to arguments, and
	a pointer to the initial environment string.  The return value
	from main() is passed, by _main(), to exit().  Therefore, you
	should always return() from main(), or call exit() directly.
 */
}
int _main()
{
/*  This function defines the standard streams, check to see which
	of them are devices, and calls the user's main() function.  The
	startup module calls this function to start the C program.  The
	following standard streams are initialized by _main():
		stdin		Standard input, may be redirected
		stdout		Standard output, may be redirected
		stderr		Usually the system console
		stdprn		The standard printer (output only)
		stdaux		The communication port (input/output)
	The global variables "_argc", "_argv" and "_envp" are used to
	store the values to be passed to the user's main().  If main()
	returns, exit() is called, with EXIT_SUCCESS status.  If a
	program doesn't use ANY standard i/o, this function can be
	replaced by one like the one in <sys\minimum.h> to make the
	program smaller.
 */
}
void exit(int status)
{
/*  Flushes and closes all open streams.  Returns <status> value to
	the operating system.
 */
}
void _exit(int status)
{
/*  Exits the program immediately, returning <status> to the OS.
 */
}
void abort()
{
/*  prints the message "Abnormal program termination" to stderr and
	calls _exit() with a status code of 3.
 */
}
int getpid()
{
/*  Return an integer value unique for this process.
 */
}
char *getenv(char *var)
{
/*  Search for <var> in the environment.  If <var> is found, a poin4er
	to it's value is returned.  NULL is returned if <var> is not found.
	WARNING:  The returned pointer points into the environment and
	must not be modified!
 */
}
int putenv(char *entry)
{
/*  Add <entry> to the environment.  <entry> can be any of the following
	forms:
		<VARIABLE>
		<VARIABLE>=
		<VARIABLE>=<value>
	The first form removes <VARIABLE> from the environment.  getenv()
	will return NULL if looking for this variable.  The second form adds
	<VARIABLE> to the environment, with a null value.  getenv() will
	return a pointer to a '\0' character if looking for this variable.
	Many environment handlers don't support such "tag variables", so
	their use is not recommended.  The final form is the most common,
	and safest to use.  <VARIABLE> is installed (or replaced) with the
	value <value>.  It should be noted that the putenv() function itself
	is not supported in many systems and therefore may not be portable.
	In addition, care should be taken to prevent overflowing the space
	allocated for the environment.  Returns TRUE for success or FALSE
	for failure.  NO OVERFLOW CHECKING IS DONE.
 */
}
void shell()
{
/*  Invoke a command line interface shell.  If the "SHELL" environment
	variable is not defined, a prompt showing the current working
	directory will be given.  Each line entered will then be passed
	to the system() function for execution until the command "exit"
	is entered to terminate the shell.  If "SHELL" is defined, and
	the "_shell_p" variable is valid, the value of "SHELL" will be
	passed to the program pointed to by "_shell_p" in order to allow
	the shell to invoke a command line interaction of its own.  If
	the "_shell_p" variable is not valid, the program defined by
	"SHELL" will be searched for along the "PATH", and executed with
	no arguments.  If the "SHELL" can't be found, the internal command
	line described above will be used.
 */
}
int system(char *command)
{
/*  Attempts to pass <command> to the shell program pointed to by
	the system variable "_shell_p".  If a valid shell can't be found
	there, the "SHELL" environment variable is searched for.  If it
	exists and is not empty, it will be the name of the shell program
	to execute the given command.  If "SHELL" is not valid, the
	"PATH" variable is used as a list of directories to search for
	the program name which is the first token of the command.  The
	extensions tried (if none is specified) are ".TTP", ".TOS",
	".PRG" and ".APP".
 */
}
int forkl(char *program[, *arg0, *arg1, ..., *argN], NULL)
{
/*  Create a child process.  Since it is not possible to do a true
	Unix-style fork(), the functionality of the fork()/exec() pair
	is provided by these fork*() functions.  A process is created,
	running concurrently if possible, which executes <program> with
	the arguments given.  A process id number is returned, which can
	be compared against the return value from wait().  Note that by
	convention <arg0> should be the name of the program that is
	being called, and is often ignored.  The fork*() functions all
	return ERROR if they for failure, or the child pid for success.
 */
}
int forklp(char *program[, *arg0, *arg1, ..., *argN], NULL)
{
/*  Use the environment variable "PATH" to find <program>. (cf: forkl)
 */
}
int forkle(char *program[, *arg0, *arg1, ..., *argN], NULL, *envp)
{
/*  Pass the environment <envp> to the child process. (cf: forkl)
 */
}
int forklpe(char *program[, *arg0, *arg1, ..., *argN], NULL, *envp)
{
/*  Use the environment variable "PATH" to find <program> and
	pass the environment <envp> to the child process. (cf: forkl)
 */
}
int forkv(char *program, **argv)
{
/*  Like forkl() except <argv> points to a NULL terminated list of
	pointers to arguments.  This is particularly useful if the number
	of arguments is not known at compile time.
 */
}
int forkvp(char *program, **argv)
{
/*  Use the environment variable "PATH" to find <program>. (cf: forkv)
 */
}
int forkve(char *program, **argv, *envp)
{
/*  Pass the environment <envp> to the child process. (cf: forkv)
 */
}
int forkvpe(char *program, **argv, *envp)
{
/*  Use the environment variable "PATH" to find <program> and
	pass the environment <envp> to the child process. (cf: forkv)
 */
}
int wait(int *rvp)
{
/*  Wait for a child process to terminate.  Return -1 if there are
	no children.  Normal return is the process id number of the
	terminated child.  <rvp> is an pointer to the place to store
	the return value and exit status.  The high byte of the word
	pointed to be <rvp> will contain the value returned from the
	child through exit().  The low byte will contain 0 if the process
	terminated normally, or an error code if abnormally.
 */
}
#include <osbind.h>
long gemdos(int func[, arg1, ..., argN])
{
/*  Call operating system trap #1 (GEMDOS) function number <func> with
	the arguments given.  Return value returned by the trap call.
 */
}
#include <osbind.h>
long bios(int func[, arg1, ..., argN])
{
/*  Call operating system trap #13 (BIOS) function number <func> with
	the arguments given.  Return value returned by the trap call.
 */
}
#include <osbind.h>
long xbios(int func[, arg1, ..., argN])
{
/*  Call operating system trap #14 (XBIOS) function number <func> with
	the arguments given.  Return value returned by the trap call.
 */
}
#include <osbind.h>
int bdos(int func, long parameter)
{
/*  Call operating system trap #2 (BDOS) function number <func> with
	passing the specified <parameter>.  Note that <parameter> must
	always be a long value, even if only a 16-bit value is required
	by the specified BDOS function.
 */
}
#include <setjmp.h>
int setjmp(jmp_buf context)
{
/*  Save <context> for longjmp(). You MUST include <setjmp.h> to use.
	Calling this function saves the current program context in the
	context buffer provided and returns zero.  A later call to the
	longjmp() function will cause the context to be restored and
	your program will continue as if it just returned from setjmp(),
	but this time with the (non-zero) return value specified in the
	longjmp() call.  THE SAVED CONTEXT WILL NOT BE VALID IF YOU
	EXIT THE FUNCTION THAT CALLED setjmp().
 */
}
#include <setjmp.h>
void longjmp(jmp_buf context, int rv)
{
/*  Return <rv> to the <context> saved by setjmp(). (cf: setjmp)
	You MUST include <setjmp.h> to use.
 */
}
#include <setjmp.h>
int catch(jmp_buf context, int (*func)())
{
/*  Execute <func> with <context> saved for throw().  You MUST include
	<setjmp.h> to use.  Return the value returned by <func>.  The main
	advantage of these functions over catch/throw is the ability to
	return zero from the function executed, and the logically "cleaner"
	encapsulation of the non-local jump operation.  These functions
	are patterned after similar functions in LISP.  (cf: setjmp/longjmp)
 */
}
#include <setjmp.h>
void throw(jump_buf context, int rv)
{
/*  Return <rv> to <context> saved by catch().  You MUST include
	<setjmp.h> to use.
 */
}


